; +++++++++ Enum Font Families Example +++++++++
; ++ Taken from Donkey's post at MASM32 Forum ++
; +++++++ Programmed by Luis Costa +++++++++++++
; ++++++++++ xandaz@hotmai.com +++++++++++++++++
; +++++++++++ Lisbon, Portugal +++++++++++++++++


.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EnumFontFamProc PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ListProc    PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350
lbID                equ     100h
.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'EnumFonts',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ List Box related +++++

hList           dd          ?
ListBoxClass    db      'LISTBOX',0
lbItem          dd          0
; ++++ others +++++

rect        RECT        <>
hDC         HDC         ?

lf          LOGFONT     <>
ENUM_FLAG       dd      FALSE
szLame      db      '.\lame.bmp',0
hBitmap     dd          ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControls
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG
    

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  PeekMessage,addr msg,NULL,0,0,PM_NOREMOVE
    or      eax,eax
    jz      no_msg
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
no_msg:
    cmp     ENUM_FLAG,FALSE
    jne     msg_loop
    invoke  GetDC,hMainWindow
    mov     hDC,eax
    mov     lf.lfCharSet,ANSI_CHARSET
    mov     lf.lfFaceName,NULL
    mov     lf.lfPitchAndFamily,NULL
    invoke  EnumFontFamiliesEx,hDC,addr lf,addr EnumFontFamProc,NULL,NULL
    invoke  ReleaseDC,hMainWindow,hDC
    mov     ENUM_FLAG,TRUE
    invoke  LoadImage,hInstance,addr szLame,IMAGE_BITMAP,32,32,LR_LOADFROMFILE
    mov hBitmap,eax
    jmp     msg_loop        

end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC   uses esi edi eax hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   hFont:DWORD
    local   MemDC:DWORD
        
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,NULL,addr ListBoxClass,NULL,WS_VISIBLE+WS_CHILD+LBS_OWNERDRAWFIXED+LBS_DISABLENOSCROLL,\
                        0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL ;cst
            mov     hList,eax
            invoke  SendMessage,hList,LB_INITSTORAGE,200,20000

       .endif 
    .elseif uMsg==WM_DRAWITEM
        mov edi,lParam
        assume  edi:PTR DRAWITEMSTRUCT
        .if [edi].itemAction==ODA_DRAWENTIRE
            mov     eax,[edi].itemData
            lea     esi,[eax].ENUMLOGFONTEX.elfLogFont
            assume  esi:PTR LOGFONT
            mov     [esi].lfEscapement,0
            invoke  CreateFontIndirect,esi
            mov     hFont,eax
            invoke  SelectObject,[edi].hdc,eax
            invoke  DrawText,[edi].hdc,addr [esi].lfFaceName,-1,addr [edi].rcItem,DT_LEFT
            invoke  DeleteObject,hFont
        .endif            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

EnumFontFamProc PROC uses edi esi eax lpEnumLogFontEx:LPSTR,lpTextMetric:LPSTR,FontType:DWORD,lParam:DWORD

    .if FontType==TRUETYPE_FONTTYPE
        invoke  SendMessage,hList,LB_ADDSTRING,NULL,lpEnumLogFontEx
    .endif
    mov eax,TRUE
    ret
    
EnumFontFamProc endp    

ListProc    PROC    uses edi esi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    ret

ListProc    endp

end start
                                    
